unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ShellAPI, ComCtrls, DateUtils;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button2: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    AProcess: TStringList;
  public
    { Public declarations }
  end;

function EnumerateWindows(hWnd: HWND; lParam: LPARAM): BOOL; stdcall; export;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function EnumerateWindows(hWnd: HWND; lParam: LPARAM): BOOL;
var
   WindowText: array[0..255] of char;
begin
   {get the text displayed in the window}
   GetWindowText(hWnd, WindowText, 255);

   {indicate if the window does not have any text}
   //if (WindowText='') then WindowText:='[No Window Text]';

   {add an item to the treeview object for a top level window}
   if WindowText <> '' then  Form1.AProcess.Add(IntToStr(hWnd));
   {continue enumeration of top level windows}
   Result:=TRUE;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  I: Integer;
  B: Boolean;
  T1: TDateTime;
  H1,H2: Hwnd;
  ProcessId: LongInt;   // holds the process identifier
  StartUpInfo: TStartUpInfo;   // holds startup information
  ProcessInfo: TProcessInformation;   // holds process information
begin
  {initialize the startup information}
  FillChar(StartupInfo, SizeOf(TStartupInfo), 0);
  with StartupInfo do
  begin
    cb := SizeOf(TStartupInfo);
    dwFlags := STARTF_USESHOWWINDOW;
    wShowWindow := SW_HIDE;
  end;
  // Ъ`N CreateProcess |]  windows gk|ҤP  ثeO win2000
  CreateProcess('c:\WINNT\NOTEPAD.exe', nil, nil, nil, False,
      NORMAL_PRIORITY_CLASS, nil, nil, StartupInfo, ProcessInfo);
  // ] CreateProcess wg槹|JɴN EnumWindows ]䤣즹 ProcessID
  // ĳ >= 3  ({JֺC)or t@ؤ覡Bz (TOJ)
  //T1 := Now;
  //while SecondsBetween(Now,T1) <= 3 do ;
  // t@Bz覡
  H2 := Panel1.Handle;
  T1 := Now;
  B := False;
  AProcess := TStringList.Create;
  try
    while not B do begin
      EnumWindows(@EnumerateWindows,0);
      for I := 0 to AProcess.Count-1 do begin
          H1 := HWND(StrToInt(AProcess.Strings[I]));
          GetWindowThreadProcessId(H1,@ProcessId);
          if ProcessId = ProcessInfo.dwProcessId then begin B := True; Break; end;
      end;
      if not B then
         if SecondsBetween(Now,T1) >= 30 then Break;
    end;
    if B then begin
       // Ĥ@q`|
       Windows.SetParent(H1,H2);
       //Memo2.Lines.Add('H1:'+IntToStr(Windows.GetParent(H1))+' H2:'+IntToStr(H2));
       Windows.MoveWindow(H1,100,100,200,300,True);
       ShowWindow(H1,SW_SHOW); // pG StartupInfo  wShowWindow := SW_HIDE ɭnϥ
    end;
  finally
    AProcess.Free;
  end;
end;

end.
